## quassel 0.6.3

=== debian/changelog ===
quassel (0.6.3-2+squeeze2) stable; urgency=low

  * Fixing missing translations in quassel-data-kde4_0.6.3-2+squeeze1_all.deb

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Mon, 17 Oct 2011 01:20:44 +0200

quassel (0.6.3-2+squeeze1) stable; urgency=low

  * Fixing security issue: ctcp DoS (Closes: #640960)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Fri, 09 Sep 2011 20:30:15 +0000

quassel (0.6.3-2) testing; urgency=low

  * correct order of changelog entries

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Fri, 08 Oct 2010 08:12:25 +0200

quassel (0.6.3-1) testing; urgency=low

  * New upstream bug fix release
  * Possible DoS attack vulnerability for multiple CTCP requests:
    http://bugs.quassel-irc.org/issues/1023 (closes: #597853)
  * contains unrelease bug fix release 0.6.2

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Sun, 03 Oct 2010 13:52:56 +0200

quassel (0.6.1-2) unstable; urgency=low

  * add dependency to gawk (closes: #592455)
  * remove manageusers.py (closes: #590644)
  * man pages updated (closes: #590643)
  * dump Debian Policy to 3.9.1

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Sun, 15 Aug 2010 23:11:16 +0200

quassel (0.6.1-1) unstable; urgency=low

  * New upstream release
  * Switch to dpkg-source 3.0 (quilt) format
  * desktop notification have been reimplemented (closes: #562974)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Wed, 21 Apr 2010 20:11:17 +0200

quassel (0.5.2-3) unstable; urgency=low

  * missing name changes quassel-core - in init and default

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 18 Feb 2010 17:12:06 +0100

quassel (0.5.2-2) unstable; urgency=low

  * Re-include init script into (closes: #569942)
  * Fixing lintian error init.d-script-missing-dependency-on-remote_fs

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 18 Feb 2010 17:11:18 +0100

quassel (0.5.2-1) unstable; urgency=low

  * New upstream release (closes: #556309)
  * Fixing minor lintian warnings:
    - copyright-with-old-dh-make-debian-copyright
    - duplicate-long-description
    - quilt-patch-missing-description
  * package descriptions have been reviewed by debian-i10n-english
  * fixing dependencies - thanks to puiparts:
    - quassel-client: phonon
    - quassel: phonon
    - quassel-kde4: kdebase-runtime, kdelibs5
    - quassel-client-kde4: kdebase-runtime, kdelibs5

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Mon, 01 Feb 2010 23:41:05 +0100

quassel (0.5.1-3) unstable; urgency=low

  * Conflict dependency added between quassel-data and quassel-data-
    kde4(closes: #566097)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 21 Jan 2010 20:36:09 +0100

quassel (0.5.1-2) unstable; urgency=low

  * KDE4 support enabled (closes: #561795)
    - package quassel-kde4 (monolithic client with KDE) has been added
    - package quassel-client-kde4 (client with KDE) has been added
    - package quassel-data-kde4 (data files) has been added
    
  * switch from cdbs to debhelper - basic idea taken from the ubuntu package
    thanks guys
  * quilt is used as patch system now

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 11 Jan 2010 12:52:45 +0100
 

quassel (0.5.1-1) unstable; urgency=low

  * New upstream release
  * dbus-x11 dependency moved to quasselclient & quassel (closes: #552061)
  * remove deprecated usage of argument -datadir (closes: #552373)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Sun, 22 Nov 2009 23:44:04 +0100

quassel (0.5.0-1) unstable; urgency=low

  * New upstream release

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 22 Oct 2009 22:19:05 +0200

quassel (0.5.0~rc2-1) experimental; urgency=low

  * New upstream release (rc2)
  * Make puiparts happy (closes: #538182)
  * manageusers.py added (closes: #549296)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Mon, 05 Oct 2009 23:13:06 +0200

quassel (0.4.2-1) unstable; urgency=low

  * New upstream release
  * watch file looks to the *.tar.bz2 directly
    no longer scanning the html page

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 28 May 2009 21:42:24 +0200

quassel (0.4.1-1) unstable; urgency=low

  * New upstream release

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Sun, 29 Mar 2009 12:51:42 +0200

quassel (0.4.0-1) unstable; urgency=low

  * New upstream release
  * repackaging no longer necessary, because svgz of oxygen icons have been
    added to the source tarball:
    - debian/repack.sh removed
    - debian/README.source removed
    - debian/watch adjusted
    - debian/rules: get-orig-source removed
  * debian/copyright updated: license for oxygen icons added
  * debian/quassel-core.logrotate added
  * debian/patcher/01_default_network_channel.patch added

 -- Thomas Mueller <thomas_mueller_ffb@online.de>  Wed, 18 Feb 2009 22:14:23 +0100

quassel (0.3.1+dfsg-3) unstable; urgency=low

  * fixing bug on upgrade (closes: #513677)
  * 'set -e' removed from ini script
  * cleanup in quassel-core.postrm

 -- Thomas Mueller <thomas_mueller_ffb@online.de>  Wed, 11 Feb 2009 21:14:33 +0100

quassel (0.3.1+dfsg-2) unstable; urgency=low

  * init script added (closes: #513677)
  * user and group for the daemon added (closes: #513677)
  * ssl certificate has been added (closes: #511169) 
    All scripts are based on the ubuntu package
    thanks to Harald Sitter <apachelogger@ubuntu.com>
  * Version in manpages have been adjusted.

 -- Thomas Mueller <thomas_mueller_ffb@online.de>  Mon, 10 Feb 2009 23:13:25 +0100

quassel (0.3.1+dfsg-1) unstable; urgency=low

  * New upstream release
  * upstream update to 0.3.0.3 (closes: #498283)
  * upstream update to 0.3.0.1 (closes: #498283)
  * watch file added - thx to Per Hausen
  * Downgrade quasselclient's dependency on quasselcore (closes: #503126)
    The packages quassel-client and quassel-core can be installed separately
    now.
    The package quassel is a dummy package, which installs client and core.
  * Additional package for the monolithic client.
  * Repackaging orig.tar.gz to remove the oxygen icons. They are no longer

